SegmentReader (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.index, class: SegmentReader

Package org.apache.lucene.index

# Class SegmentReader

java.lang.Object
org.apache.lucene.index.IndexReader
org.apache.lucene.index.LeafReader
org.apache.lucene.index.CodecReader
org.apache.lucene.index.SegmentReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public final class SegmentReader extends CodecReader
IndexReader implementation over a single segment.

Instances pointing to the same segment (but with different deletes, etc) may share the same core data.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

  `IndexReader.CacheHelper, IndexReader.CacheKey, IndexReader.ClosedListener`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `checkIntegrity()`
  Checks consistency of this reader.
  `Directory`
  `directory()`
  Returns the directory this index resides in.
  `protected void`
  `doClose()`
  Implements close.
  `IndexReader.CacheHelper`
  `getCoreCacheHelper()`
  Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this leaf regardless of deletions.
  `DocValuesProducer`
  `getDocValuesReader()`
  Expert: retrieve underlying DocValuesProducer
  `FieldInfos`
  `getFieldInfos()`
  Get the `FieldInfos` describing all fields in this reader.
  `StoredFieldsReader`
  `getFieldsReader()`
  Expert: retrieve underlying StoredFieldsReader
  `Bits`
  `getHardLiveDocs()`
  Returns the live docs that are not hard-deleted.
  `Bits`
  `getLiveDocs()`
  Returns the `Bits` representing live (not deleted) docs.
  `LeafMetaData`
  `getMetaData()`
  Return metadata about this leaf.
  `NormsProducer`
  `getNormsReader()`
  Expert: retrieve underlying NormsProducer
  `PointsReader`
  `getPointsReader()`
  Expert: retrieve underlying PointsReader
  `FieldsProducer`
  `getPostingsReader()`
  Expert: retrieve underlying FieldsProducer
  `IndexReader.CacheHelper`
  `getReaderCacheHelper()`
  Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this reader.
  `SegmentCommitInfo`
  `getSegmentInfo()`
  Return the SegmentInfoPerCommit of the segment this reader is reading.
  `String`
  `getSegmentName()`
  Return the name of the segment this reader is reading.
  `TermVectorsReader`
  `getTermVectorsReader()`
  Expert: retrieve underlying TermVectorsReader
  `KnnVectorsReader`
  `getVectorReader()`
  Expert: retrieve underlying VectorReader
  `int`
  `maxDoc()`
  Returns one greater than the largest possible document number.
  `protected void`
  `notifyReaderClosedListeners()`
  For test framework use only.
  `int`
  `numDocs()`
  Returns the number of documents in this index.
  `String`
  `toString()`

  ### Methods inherited from class org.apache.lucene.index.CodecReader

  `getBinaryDocValues, getByteVectorValues, getDocValuesSkipper, getFloatVectorValues, getNormValues, getNumericDocValues, getPointValues, getSortedDocValues, getSortedNumericDocValues, getSortedSetDocValues, searchNearestVectors, searchNearestVectors, storedFields, terms, termVectors`

  ### Methods inherited from class org.apache.lucene.index.LeafReader

  `docFreq, getContext, getDocCount, getLiveDocsWithDeletedIterator, getSumDocFreq, getSumTotalTermFreq, postings, postings, searchNearestVectors, searchNearestVectors, totalTermFreq`

  ### Methods inherited from class org.apache.lucene.index.IndexReader

  `close, decRef, ensureOpen, equals, getRefCount, hasDeletions, hashCode, incRef, leaves, numDeletedDocs, registerParentReader, tryIncRef`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### getLiveDocs

    public Bits getLiveDocs()
    Description copied from class: `LeafReader`
    Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live).

    The returned instance has been safely published for use by multiple threads without additional synchronization.

    Specified by:
      `getLiveDocs` in class `LeafReader`

  - ### doClose

    protected void doClose() throws IOException
    Description copied from class: `IndexReader`
    Implements close.
    Overrides:
      `doClose` in class `CodecReader`
    Throws:
      `IOException`

  - ### getFieldInfos

    public FieldInfos getFieldInfos()
    Description copied from class: `LeafReader`
    Get the `FieldInfos` describing all fields in this reader.

    Note: Implementations should cache the FieldInfos instance returned by this method such that subsequent calls to this method return the same instance.

    Specified by:
      `getFieldInfos` in class `LeafReader`

  - ### numDocs

    public int numDocs()
    Description copied from class: `IndexReader`
    Returns the number of documents in this index.

    NOTE: This operation may run in O(maxDoc). Implementations that can't return this number in constant-time should cache it.

    Specified by:
      `numDocs` in class `IndexReader`

  - ### maxDoc

    public int maxDoc()
    Description copied from class: `IndexReader`
    Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
    Specified by:
      `maxDoc` in class `IndexReader`

  - ### getTermVectorsReader

    public TermVectorsReader getTermVectorsReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying TermVectorsReader
    Specified by:
      `getTermVectorsReader` in class `CodecReader`

  - ### getFieldsReader

    public StoredFieldsReader getFieldsReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying StoredFieldsReader
    Specified by:
      `getFieldsReader` in class `CodecReader`

  - ### getPointsReader

    public PointsReader getPointsReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying PointsReader
    Specified by:
      `getPointsReader` in class `CodecReader`

  - ### getNormsReader

    public NormsProducer getNormsReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying NormsProducer
    Specified by:
      `getNormsReader` in class `CodecReader`

  - ### getDocValuesReader

    public DocValuesProducer getDocValuesReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying DocValuesProducer
    Specified by:
      `getDocValuesReader` in class `CodecReader`

  - ### getVectorReader

    public KnnVectorsReader getVectorReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying VectorReader
    Specified by:
      `getVectorReader` in class `CodecReader`

  - ### getPostingsReader

    public FieldsProducer getPostingsReader()
    Description copied from class: `CodecReader`
    Expert: retrieve underlying FieldsProducer
    Specified by:
      `getPostingsReader` in class `CodecReader`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### getSegmentName

    public String getSegmentName()
    Return the name of the segment this reader is reading.

  - ### getSegmentInfo

    public SegmentCommitInfo getSegmentInfo()
    Return the SegmentInfoPerCommit of the segment this reader is reading.

  - ### directory

    public Directory directory()
    Returns the directory this index resides in.

  - ### notifyReaderClosedListeners

    protected void notifyReaderClosedListeners() throws IOException
    Description copied from class: `IndexReader`
    For test framework use only.
    Overrides:
      `notifyReaderClosedListeners` in class `IndexReader`
    Throws:
      `IOException`

  - ### getReaderCacheHelper

    public IndexReader.CacheHelper getReaderCacheHelper()
    Description copied from class: `IndexReader`
    Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this reader. Two readers that have different data or different sets of deleted documents will be considered different.

    A return value of `null` indicates that this reader is not suited for caching, which is typically the case for short-lived wrappers that alter the content of the wrapped reader.

    Specified by:
      `getReaderCacheHelper` in class `IndexReader`

  - ### getCoreCacheHelper

    public IndexReader.CacheHelper getCoreCacheHelper()
    Description copied from class: `LeafReader`
    Optional method: Return a `IndexReader.CacheHelper` that can be used to cache based on the content of this leaf regardless of deletions. Two readers that have the same data but different sets of deleted documents or doc values updates may be considered equal. Consider using `IndexReader.getReaderCacheHelper()` if you need deletions or dv updates to be taken into account.

    A return value of `null` indicates that this reader is not suited for caching, which is typically the case for short-lived wrappers that alter the content of the wrapped leaf reader.

    Specified by:
      `getCoreCacheHelper` in class `LeafReader`

  - ### getMetaData

    public LeafMetaData getMetaData()
    Description copied from class: `LeafReader`
    Return metadata about this leaf.
    Specified by:
      `getMetaData` in class `LeafReader`

  - ### getHardLiveDocs

    public Bits getHardLiveDocs()
    Returns the live docs that are not hard-deleted. This is an expert API to be used with soft-deletes to filter out document that hard deleted for instance due to aborted documents or to distinguish soft and hard deleted documents ie. a rolled back tombstone.
    WARNING: This API is experimental and might change in incompatible ways in the next release.

  - ### checkIntegrity

    public void checkIntegrity() throws IOException
    Description copied from class: `LeafReader`
    Checks consistency of this reader.

    Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

    Overrides:
      `checkIntegrity` in class `CodecReader`
    Throws:
      `IOException`